/*

	ELEMENTAL_DLLSAMPLE.CPP

	Team Elemental sample DSDLL showing how to allow pseudo-execution of GPG functions in DSDLL's.

	Changes:
	- 06/09/02 : Canti, v0.1, initial test version
*/


#include <windows.h>
#include "elemental_dllskrit.h"

#define APICALL __declspec(dllexport) // shortcut redefinition for clarity


/*************************
** Function Definitions **
*************************/

BOOL APIENTRY DllMain(HANDLE, DWORD, LPVOID)
{
	return TRUE;
} // end DllMain()


/*************************
** Class Implementation **
*************************/

class DLLSample
{

/***************************************************************************************
**
** Name: InitializeQueue
**
** Desc: Exposes the static lib function, QueueInit, to the skrit file
**
** NOTE: This function, in some form or other, must be present in your DSDLL in order
**       to expose the static library's queue initialization to the skrit file
**
** unsigned int GoID - the GoID for the container object
**
***************************************************************************************/

static APICALL void InitializeQueue(unsigned int GoID)
{
	QueueInit(GoID);
} // end InitializeQueue

/***************************************************************************************
**
** Name: GrabMessage
**
** Desc: Exposes the static lib function, GetNextMessage, to the skrit file
**
** NOTE: This function, in some form or other, must be present in your DSDLL in order
**       to expose the static library's own GetNextMessage to the skrit file
**
** unsigned int GoID - the GoID for the container object
**
***************************************************************************************/

static APICALL const char* GrabMessage(unsigned int GoID)
{
	return(GetNextMessage(GoID));
} // end GrabMessage

/***************************************************************************************
**
** Name: SampleMessageBox
**
** Desc: Demonstrates execution of skrit via the message queue
**
***************************************************************************************/

static APICALL void SampleMessageBox(void)
{
	PushMessage("Report.MessageBoxF(\"Demonstrating pseudo-execution of dynamic skrit from a DSDLL!\");");
} // end SampleMessageBox

}; // end DLLSample
